"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const databasetool_interfaces_1 = require("../tools/databasetool.interfaces");
const select_helper_class_1 = require("../tools/select.helper.class");
var MessageFields;
(function (MessageFields) {
    MessageFields["id"] = "id";
    MessageFields["user"] = "user";
    MessageFields["account"] = "account";
    MessageFields["date_created"] = "date_created";
    MessageFields["date_sent"] = "date_sent";
    MessageFields["sent_to"] = "sent_to";
    MessageFields["sent_from"] = "sent_from";
    MessageFields["body"] = "body";
    MessageFields["ourNumber"] = "ourNumber";
    MessageFields["theirNumber"] = "theirNumber";
})(MessageFields = exports.MessageFields || (exports.MessageFields = {}));
let customFunctions = {
    someCustom: (input) => {
        return {
            field: 'id',
            type: databasetool_interfaces_1.ConditionType.gt,
            value: input + ' AND THRN SOME'
        };
    }
};
function MessageSelect(messageSelect) {
    let genericSelect = messageSelect;
    let tableHelper = new select_helper_class_1.ConvertSpecificTableSelectIntoGeneralSelectWizard({ base: 'Messages', customGroup: genericSelect, CustomProperties: customFunctions });
    return tableHelper.returnTable();
}
exports.MessageSelect = MessageSelect;
//# sourceMappingURL=messages.select.class.js.map