import { SelectTableCreator } from './create.table.select.from.database'
function normalizeWS(s: any): String {
    s = s.trim()
    s = s.match(/\S+/g);
    return s ? s.join(' ') : '';
}
describe(" Should create a select wizard instance", () => {
    //This passes but I don't see the need to query the database each time the tests restart
    xit("should return the table properties", async () => {
        let newSelectTableWizard = new SelectTableCreator('Messages')
        await newSelectTableWizard.init()
        expect(newSelectTableWizard.table_properties).toEqual([{ "Default": null, "Extra": "auto_increment", "Field": "id", "Key": "PRI", "Null": "NO", "Type": "int(6) unsigned" }, { "Default": null, "Extra": "", "Field": "date_updated", "Key": "MUL", "Null": "YES", "Type": "timestamp" }, { "Default": "CURRENT_TIMESTAMP", "Extra": "", "Field": "date_created", "Key": "MUL", "Null": "NO", "Type": "timestamp" }, { "Default": null, "Extra": "", "Field": "date_sent", "Key": "MUL", "Null": "YES", "Type": "datetime" }, { "Default": null, "Extra": "", "Field": "body", "Key": "", "Null": "NO", "Type": "text" }, { "Default": null, "Extra": "", "Field": "sid", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "sent_to", "Key": "MUL", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "sent_from", "Key": "MUL", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "status", "Key": "MUL", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "twilio_date_created", "Key": "MUL", "Null": "YES", "Type": "datetime" }, { "Default": null, "Extra": "", "Field": "account_sid", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "messaging_service_sid", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "num_segments", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "user", "Key": "MUL", "Null": "NO", "Type": "int(10) unsigned" }, { "Default": null, "Extra": "", "Field": "num_media", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "direction", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "api_version", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "price", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "price_unit", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "error_code", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "error_message", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "uri", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "media_uri", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "OurNumber", "Key": "MUL", "Null": "NO", "Type": "text" }, { "Default": null, "Extra": "", "Field": "TheirNumber", "Key": "MUL", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "ToCountry", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "ToState", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "ToCity", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "ToZip", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "FromCountry", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "FromState", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "FromCity", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "FromZip", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "scheduled_time", "Key": "", "Null": "YES", "Type": "datetime" }, { "Default": null, "Extra": "", "Field": "sent_id", "Key": "", "Null": "YES", "Type": "int(6) unsigned" }, { "Default": null, "Extra": "", "Field": "tag", "Key": "", "Null": "YES", "Type": "int(10) unsigned" }, { "Default": null, "Extra": "", "Field": "group_link", "Key": "", "Null": "YES", "Type": "int(10) unsigned" }, { "Default": null, "Extra": "", "Field": "account", "Key": "", "Null": "NO", "Type": "int(10) unsigned" }, { "Default": "0", "Extra": "", "Field": "needles_synced", "Key": "", "Null": "YES", "Type": "tinyint(1)" }, { "Default": null, "Extra": "", "Field": "integration_id", "Key": "", "Null": "YES", "Type": "int(11)" }, { "Default": null, "Extra": "", "Field": "media_uri1", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri2", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri3", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri4", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri5", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri6", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri7", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri8", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri9", "Key": "", "Null": "YES", "Type": "varchar(255)" }])
    })

    it("should return fieldEnums", async () => {
        let newSelectTableWizard = new SelectTableCreator('Messages')
        newSelectTableWizard.table_properties = [{ "Default": null, "Extra": "auto_increment", "Field": "id", "Key": "PRI", "Null": "NO", "Type": "int(6) unsigned" }, { "Default": null, "Extra": "", "Field": "date_updated", "Key": "MUL", "Null": "YES", "Type": "timestamp" }, { "Default": "CURRENT_TIMESTAMP", "Extra": "", "Field": "date_created", "Key": "MUL", "Null": "NO", "Type": "timestamp" }, { "Default": null, "Extra": "", "Field": "date_sent", "Key": "MUL", "Null": "YES", "Type": "datetime" }, { "Default": null, "Extra": "", "Field": "body", "Key": "", "Null": "NO", "Type": "text" }, { "Default": null, "Extra": "", "Field": "sid", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "sent_to", "Key": "MUL", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "sent_from", "Key": "MUL", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "status", "Key": "MUL", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "twilio_date_created", "Key": "MUL", "Null": "YES", "Type": "datetime" }, { "Default": null, "Extra": "", "Field": "account_sid", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "messaging_service_sid", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "num_segments", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "user", "Key": "MUL", "Null": "NO", "Type": "int(10) unsigned" }, { "Default": null, "Extra": "", "Field": "num_media", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "direction", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "api_version", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "price", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "price_unit", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "error_code", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "error_message", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "uri", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "media_uri", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "OurNumber", "Key": "MUL", "Null": "NO", "Type": "text" }, { "Default": null, "Extra": "", "Field": "TheirNumber", "Key": "MUL", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "ToCountry", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "ToState", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "ToCity", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "ToZip", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "FromCountry", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "FromState", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "FromCity", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "FromZip", "Key": "", "Null": "YES", "Type": "text" }, { "Default": null, "Extra": "", "Field": "scheduled_time", "Key": "", "Null": "YES", "Type": "datetime" }, { "Default": null, "Extra": "", "Field": "sent_id", "Key": "", "Null": "YES", "Type": "int(6) unsigned" }, { "Default": null, "Extra": "", "Field": "tag", "Key": "", "Null": "YES", "Type": "int(10) unsigned" }, { "Default": null, "Extra": "", "Field": "group_link", "Key": "", "Null": "YES", "Type": "int(10) unsigned" }, { "Default": null, "Extra": "", "Field": "account", "Key": "", "Null": "NO", "Type": "int(10) unsigned" }, { "Default": "0", "Extra": "", "Field": "needles_synced", "Key": "", "Null": "YES", "Type": "tinyint(1)" }, { "Default": null, "Extra": "", "Field": "integration_id", "Key": "", "Null": "YES", "Type": "int(11)" }, { "Default": null, "Extra": "", "Field": "media_uri1", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri2", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri3", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri4", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri5", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri6", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri7", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri8", "Key": "", "Null": "YES", "Type": "varchar(255)" }, { "Default": null, "Extra": "", "Field": "media_uri9", "Key": "", "Null": "YES", "Type": "varchar(255)" }]
        expect(normalizeWS(newSelectTableWizard.fieldsEnum)).toEqual(normalizeWS(`
        export enum MessagesFields {
            id = 'id',
            date_updated = 'date_updated',
            date_created = 'date_created',
            date_sent = 'date_sent',
            body = 'body',
            sid = 'sid',
            sent_to = 'sent_to',
            sent_from = 'sent_from',
            status = 'status',
            twilio_date_created = 'twilio_date_created',
            account_sid = 'account_sid',
            messaging_service_sid = 'messaging_service_sid',
            num_segments = 'num_segments',
            user = 'user',
            num_media = 'num_media',
            direction = 'direction',
            api_version = 'api_version',
            price = 'price',
            price_unit = 'price_unit',
            error_code = 'error_code',
            error_message = 'error_message',
            uri = 'uri',
            media_uri = 'media_uri',
            OurNumber = 'OurNumber',
            TheirNumber = 'TheirNumber',
            ToCountry = 'ToCountry',
            ToState = 'ToState',
            ToCity = 'ToCity',
            ToZip = 'ToZip',
            FromCountry = 'FromCountry',
            FromState = 'FromState',
            FromCity = 'FromCity',
            FromZip = 'FromZip',
            scheduled_time = 'scheduled_time',
            sent_id = 'sent_id',
            tag = 'tag',
            group_link = 'group_link',
            account = 'account',
            needles_synced = 'needles_synced',
            integration_id = 'integration_id',
            media_uri1 = 'media_uri1',
            media_uri2 = 'media_uri2',
            media_uri3 = 'media_uri3',
            media_uri4 = 'media_uri4',
            media_uri5 = 'media_uri5',
            media_uri6 = 'media_uri6',
            media_uri7 = 'media_uri7',
            media_uri8 = 'media_uri8',
            media_uri9 = 'media_uri9',
        }
            `))


        expect(normalizeWS(newSelectTableWizard.fullPage)).toEqual(normalizeWS(`
    import { ConditionType, ConditionGroupType, NumberCondition, StringCondition, DateCondition, GenericSelectQuery, OrderByDirections, Condition } from './databasetool.interfaces'
    import { SelectWizard } from './Table.class'
    import { TableHelper } from './table.helper.class'


        export enum MessagesFields {
            id = 'id',
            date_updated = 'date_updated',
            date_created = 'date_created',
            date_sent = 'date_sent',
            body = 'body',
            sid = 'sid',
            sent_to = 'sent_to',
            sent_from = 'sent_from',
            status = 'status',
            twilio_date_created = 'twilio_date_created',
            account_sid = 'account_sid',
            messaging_service_sid = 'messaging_service_sid',
            num_segments = 'num_segments',
            user = 'user',
            num_media = 'num_media',
            direction = 'direction',
            api_version = 'api_version',
            price = 'price',
            price_unit = 'price_unit',
            error_code = 'error_code',
            error_message = 'error_message',
            uri = 'uri',
            media_uri = 'media_uri',
            OurNumber = 'OurNumber',
            TheirNumber = 'TheirNumber',
            ToCountry = 'ToCountry',
            ToState = 'ToState',
            ToCity = 'ToCity',
            ToZip = 'ToZip',
            FromCountry = 'FromCountry',
            FromState = 'FromState',
            FromCity = 'FromCity',
            FromZip = 'FromZip',
            scheduled_time = 'scheduled_time',
            sent_id = 'sent_id',
            tag = 'tag',
            group_link = 'group_link',
            account = 'account',
            needles_synced = 'needles_synced',
            integration_id = 'integration_id',
            media_uri1 = 'media_uri1',
            media_uri2 = 'media_uri2',
            media_uri3 = 'media_uri3',
            media_uri4 = 'media_uri4',
            media_uri5 = 'media_uri5',
            media_uri6 = 'media_uri6',
            media_uri7 = 'media_uri7',
            media_uri8 = 'media_uri8',
            media_uri9 = 'media_uri9',
        }


        interface MessagesCondition {
            id?: number | NumberCondition,
            date_updated?: Date | DateCondition,
            date_created?: Date | DateCondition,
            date_sent?: Date | DateCondition,
            body?: String | StringCondition,
            sid?: String | StringCondition,
            sent_to?: String | StringCondition,
            sent_from?: String | StringCondition,
            status?: String | StringCondition,
            twilio_date_created?: Date | DateCondition,
            account_sid?: String | StringCondition,
            messaging_service_sid?: String | StringCondition,
            num_segments?: String | StringCondition,
            user?: number | NumberCondition,
            num_media?: String | StringCondition,
            direction?: String | StringCondition,
            api_version?: String | StringCondition,
            price?: String | StringCondition,
            price_unit?: String | StringCondition,
            error_code?: String | StringCondition,
            error_message?: String | StringCondition,
            uri?: String | StringCondition,
            media_uri?: String | StringCondition,
            OurNumber?: String | StringCondition,
            TheirNumber?: String | StringCondition,
            ToCountry?: String | StringCondition,
            ToState?: String | StringCondition,
            ToCity?: String | StringCondition,
            ToZip?: String | StringCondition,
            FromCountry?: String | StringCondition,
            FromState?: String | StringCondition,
            FromCity?: String | StringCondition,
            FromZip?: String | StringCondition,
            scheduled_time?: Date | DateCondition,
            sent_id?: number | NumberCondition,
            tag?: number | NumberCondition,
            group_link?: number | NumberCondition,
            account?: number | NumberCondition,
            needles_synced?: number | NumberCondition,
            integration_id?: number | NumberCondition,
            media_uri1?: String | StringCondition,
            media_uri2?: String | StringCondition,
            media_uri3?: String | StringCondition,
            media_uri4?: String | StringCondition,
            media_uri5?: String | StringCondition,
            media_uri6?: String | StringCondition,
            media_uri7?: String | StringCondition,
            media_uri8?: String | StringCondition,
            media_uri9?: String | StringCondition,
        }



    interface MessagesSelectQuery {
        fields: Array<MessagesFields>,
        where: MessagesConditionGroup | MessagesCondition
    }

    interface MessagesConditionGroup {
        type: ConditionGroupType,
        conditions: Array<MessagesConditionGroup | MessagesCondition> | MessagesCondition
    }


    interface MessagesSelectQuery {
        fields: Array<MessagesFields>,
        where: MessagesConditionGroup | MessagesCondition,
        limit?: number,
        orderBy?: MessagesSelectOrderBy
    }

    interface MessagesSelectOrderBy {
        field: MessagesFields,
        direction: OrderByDirections
    }


    let customFunctions: any = {
        someCustom: (input: any): Condition => {
            return {
                field: 'id',
                type: ConditionType.gt,
                value: input + ' AND THRN SOME'
            }
        }
    }

    export function MessagesSelect(MessagesSelect: MessagesSelectQuery): SelectWizard {
        let genericSelect = MessagesSelect as any as GenericSelectQuery
        let tableHelper = new TableHelper({ base: 'Messages', customGroup: genericSelect, CustomProperties: customFunctions })
        return tableHelper.returnTable()
    }


            `))
    })


    ///Works
    xit("Should write to file", async () => {
        let newSelectTableWizard = new SelectTableCreator('Coupons')
        await newSelectTableWizard.init()
        expect(newSelectTableWizard.table_properties).toEqual([{ "Default": null, "Extra": "auto_increment", "Field": "id", "Key": "PRI", "Null": "NO", "Type": "int(11)" }, { "Default": null, "Extra": "", "Field": "code", "Key": "UNI", "Null": "NO", "Type": "varchar(45)" }, { "Default": null, "Extra": "", "Field": "off", "Key": "", "Null": "YES", "Type": "int(11)" }, { "Default": "1", "Extra": "", "Field": "status", "Key": "", "Null": "NO", "Type": "int(11)" }, { "Default": "CURRENT_TIMESTAMP", "Extra": "", "Field": "created_at", "Key": "", "Null": "YES", "Type": "timestamp" }, { "Default": null, "Extra": "", "Field": "offType", "Key": "", "Null": "YES", "Type": "varchar(10)" }])
        newSelectTableWizard.writeToFile(__dirname + '/here.ts')

    })
})