import { SelectWizardProperties, ConditionGroup, Condition, GenericOrderBy } from './databasetool.interfaces';
export declare class SelectWizard {
    constructor(selectWizardProperties: SelectWizardProperties);
    limit: number;
    base: String;
    fields: Array<String>;
    conditions: ConditionGroupClass;
    orderBy: GenericOrderBy;
    groupBy: string;
    fieldsString(): String;
    getOrderByString(): string;
    getGroupByString(): string;
    execute(): Promise<{}>;
    stringify(): string;
}
export declare class ConditionGroupClass {
    constructor(conditionGroup: ConditionGroup);
    private type;
    private conditions;
    static isConditionGroup(arg: any): arg is ConditionGroup;
    private returnArrayOfConditionStrings;
    stringify(): String;
}
export declare class ConditionClass {
    private condition;
    constructor(condition: Condition);
    stringify(): String;
}
