import { GenericSelectQuery, SelectWizardProperties, ConditionGroup, Condition, GenericOrderBy } from './databasetool.interfaces';
import { SelectWizard } from './select.class';
export declare class ConvertSpecificTableSelectIntoGeneralSelectWizard {
    constructor(CreatorParameters: {
        base: string;
        customGroup: GenericSelectQuery;
        CustomProperties?: any;
    });
    groupBy: string;
    fields: Array<String>;
    customFunctions: any;
    base: String;
    where: ConditionGroup;
    limit: number;
    orderBy: GenericOrderBy;
    readonly selectWizardProperties: SelectWizardProperties;
    generateWhere(inputWhere: any): ConditionGroup;
    parseConditionOrConditionGroup(conditionOrConditionGroup: any, parentConditionGroup?: ConditionGroup): ConditionGroup;
    returnNewCondtionGroup(condition: any): ConditionGroup;
    parseCondtionGroup(conditionGroup: any): ConditionGroup;
    parseCondtionToArrayOfConditions(conditionGroup: any): Array<Condition>;
    returnTable(): SelectWizard;
}
